#include <string.h>
#include "phero_loop_functions.h"
#include <argos3/core/simulator/simulator.h>
#include <argos3/core/utility/configuration/argos_configuration.h>
#include <argos3/plugins/robots/foot-bot/simulator/footbot_entity.h>
#include <controllers/footbot_foraging/footbot_foraging.h>

using namespace argos;
/****************************************/
/****************************************/

static const Real MIN_DISTANCE = 0.05f;
/* Convenience constant to avoid calculating the square root in PostStep() */
static const Real MIN_DISTANCE_SQUARED = MIN_DISTANCE * MIN_DISTANCE;


CPheroLoopFunctions::CPheroLoopFunctions() :

      pheroStart3d(0.0f, 0.0f, 0.0f),
      pheroEnd3d(1.0f, 0.0f, 0.0f),
      targetPhero(pheroStart3d, pheroEnd3d),
      textPos(0.0,0.0, 0.0),
      textStr("Test Test Test"),
      cPos(0.0, 0.0, 0.0),
      xStrPos(0.0, 0.0, 0.0),
      yStrPos(0.0, 0.0, 0.0),
      xIndex(0),
      yIndex(0),
      pheroVal(0.0),
      pheroMat()
      {}
//    m_cForagingArenaSideX(-0.9f, 1.7f),
//    m_cForagingArenaSideY(-1.7f, 1.7f),
//    m_pcFloor(NULL),
//    m_pcRNG(NULL),
//    m_unCollectedFood(0),
//    m_nEnergy(0),
//    m_unEnergyPerFoodItem(1),
//    m_unEnergyPerWalkingRobot(1) {

/****************************************/
/****************************************/

void CPheroLoopFunctions::Init(TConfigurationNode& t_node) {

   try {
      TConfigurationNode& tPhero = GetNode(t_node, "phero");
      /* Get a pointer to the floor entity */
      //m_pcFloor = &GetSpace().GetFloorEntity();
      /* Get the number of food items we want to be scattered from XML */
      //UInt32 unFoodItems;
      //29042020 Seongin pheromone initialisation
      GetNodeAttribute(tPhero, "PheroStartX", PheroStartX);
      GetNodeAttribute(tPhero, "PheroStartY", PheroStartY);
      GetNodeAttribute(tPhero, "PheroEndX", PheroEndX);
      GetNodeAttribute(tPhero, "PheroEndY", PheroEndY);
      


      /* Get the number of food items we want to be scattered from XML */
      //GetNodeAttribute(tForaging, "radius", m_fFoodSquareRadius);
      //m_fFoodSquareRadius *= m_fFoodSquareRadius;
      /* Create a new RNG */
      //m_pcRNG = CRandom::CreateRNG("argos");
      /* Distribute uniformly the items in the environment */
    //   for(UInt32 i = 0; i < unFoodItems; ++i) {
    //      m_cFoodPos.push_back(
    //         CVector2(m_pcRNG->Uniform(m_cForagingArenaSideX),
    //                  m_pcRNG->Uniform(m_cForagingArenaSideY)));
    //   }
      /* Get the output file name from XML */
      //GetNodeAttribute(tForaging, "output", m_strOutput);
      /* Open the file, erasing its contents */
      //m_cOutput.open(m_strOutput.c_str(), std::ios_base::trunc | std::ios_base::out);
      //m_cOutput << "# clock\twalking\tresting\tcollected_food\tenergy" << std::endl;
      /* Get energy gain per item collected */
      //GetNodeAttribute(tForaging, "energy_per_item", m_unEnergyPerFoodItem);
      /* Get energy loss per walking robot */
      //GetNodeAttribute(tForaging, "energy_per_walking_robot", m_unEnergyPerWalkingRobot);
   }
   catch(CARGoSException& ex) {
      THROW_ARGOSEXCEPTION_NESTED("Error parsing loop functions!", ex);
   }

   // 20200527 test
   // const UInt32 m_unPixelsPerMeter = 10;
   // CVector2 m_cHalfArenaSize;
   // CVector2 m_cArenaCenter;
   // CVector2 scaledArenaSize;

   // const CVector3& cArenaSize = CSimulator::GetInstance().GetSpace().GetArenaSize();
   // const CVector3& cArenaCenter = CSimulator::GetInstance().GetSpace().GetArenaCenter();
   // m_cArenaCenter.Set(cArenaCenter.GetX(), cArenaCenter.GetY());
   
   
 
 
}

/****************************************/
/****************************************/

void CPheroLoopFunctions::Reset() {
   //  pheroStart3d.Set(0.0f, 0.0f, 0.0f);
   //  pheroEnd3d.Set(0.0f, 0.0f, 0.0f);
   //  targetPhero.Set(pheroStart3d, pheroEnd3d);
   //  /* Get the map of all foot-bots from the space */
   //  CSpace::TMapPerType& tFBMap = GetSpace().GetEntitiesByType("foot-bot");
   //  /* Go through them */
   //  for(CSpace::TMapPerType::iterator it = tFBMap.begin();
   //     it != tFBMap.end();
   //     ++it) {
   //    /* Create a pointer to the current foot-bot */
   //    CFootBotEntity* pcFB = any_cast<CFootBotEntity*>(it->second);
   //    /* Clear the waypoint vector */
   //    m_tWaypoints[pcFB].clear();
   //    /* Add the initial position of the foot-bot */
   //    m_tWaypoints[pcFB].push_back(pcFB->GetEmbodiedEntity().GetOriginAnchor().Position);
 //}
}

 

/****************************************/
/****************************************/

void CPheroLoopFunctions::Destroy() {
   /* Close the file */
   m_cOutput.close();
}

/****************************************/
/****************************************/

// CColor CForagingLoopFunctions::GetFloorColor(const CVector2& c_position_on_plane) {
//    if(c_position_on_plane.GetX() < -1.0f) {
//       return CColor::GRAY50;
//    }
//    for(UInt32 i = 0; i < m_cFoodPos.size(); ++i) {
//       if((c_position_on_plane - m_cFoodPos[i]).SquareLength() < m_fFoodSquareRadius) {
//          return CColor::BLACK;
//       }
//    }
//    return CColor::WHITE;
// }

/****************************************/
/****************************************/

//20200525 The matrix and the element of the matrix with the index (x,y) should be returned
// Real CPheroLoopFunctions::GetPhero(const CVector2& c_position_on_plane) {
//    int x_phero{c_position_on_plane.GetX()};
//    int y_phero{y_position_on_plane.GetY()};


//    return x_phero;
// }

void CPheroLoopFunctions::PreStep() {
   // pheroStart3d.Set(-2.0f, -2.0f, 0.3f);
   // pheroEnd3d.Set(2.0f, 2.0f, 0.0f);
   // targetPhero.Set(pheroStart3d, pheroEnd3d);
}

/****************************************/
/****************************************/

void CPheroLoopFunctions::PostStep() {
   /* Get the map of all foot-bots from the space */
   CSpace::TMapPerType& tFBMap = GetSpace().GetEntitiesByType("foot-bot");
   /* Go through them */
   for(CSpace::TMapPerType::iterator it = tFBMap.begin();
       it != tFBMap.end();
       ++it) {
      /* Create a pointer to the current foot-bot */
      CFootBotEntity* pcFB = any_cast<CFootBotEntity*>(it->second);
      /* Get the current x, y position of the foot-bot */
      cPos.Set(pcFB->GetEmbodiedEntity().GetOriginAnchor().Position.GetX(),
               pcFB->GetEmbodiedEntity().GetOriginAnchor().Position.GetY(),
               pcFB->GetEmbodiedEntity().GetOriginAnchor().Position.GetZ());
      /* Position vectors to visualise x and y coordinates of the robot */
      xStrPos.Set(pcFB->GetEmbodiedEntity().GetOriginAnchor().Position.GetX(),
               pcFB->GetEmbodiedEntity().GetOriginAnchor().Position.GetY(),
               pcFB->GetEmbodiedEntity().GetOriginAnchor().Position.GetZ() + 0.15);
      yStrPos.Set(pcFB->GetEmbodiedEntity().GetOriginAnchor().Position.GetX(), 
                pcFB->GetEmbodiedEntity().GetOriginAnchor().Position.GetY(),
                pcFB->GetEmbodiedEntity().GetOriginAnchor().Position.GetZ() + 0.1);
   } 
   xIndex = PosToIdx(cPos.GetX(), 100, 2.5);
   yIndex = PosToIdx(cPos.GetY(), 100, 2.5);

   // Assigning a value within a range
   pheroMat.SetRange(PosToIdx(-0.1, 100, 2.5), PosToIdx(0.1, 100, 2.5), 
                     PosToIdx(-2.5, 100, 2.5), PosToIdx(2.5, 100, 2.5),
                      0.6);
   pheroVal = pheroMat(xIndex, yIndex);
   xStr = std::to_string(cPos.GetX());
   yStr = std::to_string(cPos.GetY());
   pheroStr = std::to_string(pheroVal);


   

   // for(Real i = 0.0; i < PheroCoordinate; i++){
   //    m_tVectors.push_back(CVector3(i, i, 0.1));
      
   // }
}

CVector3 CPheroLoopFunctions::GetPheroStart3d() {
   return pheroStart3d;
}

CVector3 CPheroLoopFunctions::GetPheroEnd3d() {
   return pheroEnd3d;
}

// 20200529 Converting position value into the index for the pheromon matrix
UInt32 CPheroLoopFunctions::PosToIdx(Real pos, UInt32 res, Real halfArena){
   UInt32 idxForMat = static_cast<UInt32>(res * (pos + halfArena));
   return idxForMat;
}



/****************************************/
/****************************************/

REGISTER_LOOP_FUNCTIONS(CPheroLoopFunctions, "phero_loop_functions")