#ifndef PHERO_LOOP_FUNCTIONS_H
#define PHERO_LOOP_FUNCTIONS_H

#include <argos3/core/simulator/loop_functions.h>
#include <argos3/core/simulator/entity/floor_entity.h>
#include <argos3/core/utility/math/range.h>
#include <argos3/core/utility/math/rng.h>
//#include <../../entities/phero_entities/phero_entity.h>
#include <argos3/plugins/robots/foot-bot/simulator/footbot_entity.h>

using namespace argos;

class CPheroLoopFunctions : public CLoopFunctions {

public:

   typedef std::map<CFootBotEntity*, std::vector<CVector3> > TWaypointMap;
   TWaypointMap m_tWaypoints;

   //std::vector<CVector3> m_tVectors;

public:

   CPheroLoopFunctions();

   virtual ~CPheroLoopFunctions() {}

   virtual void Init(TConfigurationNode& t_tree);
   
   virtual void Reset();
   virtual void Destroy();
   //virtual CColor GetFloorColor(const CVector2& c_position_on_plane);
   //virtual Real GetPhero(const CVector2& c_position_on_plane);
   virtual void PreStep();

   virtual void PostStep();

   void UpdatePheromone();

   UInt32 PosToIdx(Real pos, UInt32 res, Real halfArena);

   inline const TWaypointMap& GetWaypoint() const {
      return m_tWaypoints;
   }

   CVector3 GetPheroStart3d();
   CVector3 GetPheroEnd3d();
   CRay3 targetPhero;
   CVector3 textPos;
   std::string textStr;
   CVector3 pheroStart3d;
   CVector3 pheroEnd3d;

   CVector3 cPos;
   CVector3 xStrPos;
   CVector3 yStrPos;
   UInt32 xIndex;
   UInt32 yIndex;
   Real pheroVal;
   std::string pheroStr;
   std::string xStr;
   std::string yStr;
   CMatrix<500, 500> pheroMat;

   

protected:


   


private:
   /*
   Real m_fFoodSquareRadius;
   CRange<Real> m_cForagingArenaSideX, m_cForagingArenaSideY;
   std::vector<CVector2> m_cFoodPos;
   CFloorEntity* m_pcFloor;
   CRandom::CRNG* m_pcRNG;

   std::string m_strOutput;
  

   UInt32 m_unCollectedFood;
   SInt64 m_nEnergy;
   UInt32 m_unEnergyPerFoodItem;
   UInt32 m_unEnergyPerWalkingRobot;*/
   std::ofstream m_cOutput;

   Real PheroStartX;
   Real PheroStartY;
   Real PheroEndX;
   Real PheroEndY;
   


};

#endif
