#include <string.h>
#include "phero_qt_user_functions.h"
#include <controllers/footbot_foraging/footbot_foraging.h>
#include <argos3/core/simulator/entity/controllable_entity.h>

using namespace argos;

/****************************************/
/****************************************/

CPheroQTUserFunctions::CPheroQTUserFunctions() :
   loopFunctions(dynamic_cast<CPheroLoopFunctions&>(CSimulator::GetInstance().GetLoopFunctions()))
{
   //RegisterUserFunction<CPheroQTUserFunctions, CFloorEntity>(&CPheroQTUserFunctions::DrawPhero);
}

/****************************************/
/****************************************/

void CPheroQTUserFunctions::DrawInWorld(){

   for(CPheroLoopFunctions::TWaypointMap::const_iterator it = loopFunctions.GetWaypoint().begin();
       it != loopFunctions.GetWaypoint().end();
       ++it) {
       DrawWaypoints(it->second);
   }
   DrawText(loopFunctions.textPos, loopFunctions.pheroStr);
   DrawText(loopFunctions.xStrPos, loopFunctions.xStr);
   DrawText(loopFunctions.yStrPos, loopFunctions.yStr);
   DrawRay(CRay3(loopFunctions.pheroStart3d, loopFunctions.pheroEnd3d), CColor::BLACK, 20.0f);

}

void CPheroQTUserFunctions::DrawWaypoints(const std::vector<CVector3>& c_waypoints) {
   
   if(c_waypoints.size()>1){
      size_t unStart = 0;
      size_t unEnd = 1;
      while(unEnd < c_waypoints.size()) {
         DrawRay(CRay3(c_waypoints[unEnd],
                       c_waypoints[unStart]), CColor::BLACK, 5.0f);
         ++unStart;
         ++unEnd;
      }
   }
}

void CPheroQTUserFunctions::DrawPhero() {
   DrawRay(loopFunctions.targetPhero, CColor::BLACK, 30.0f);
   // m_pheroStart3d = loopFunctions.GetPheroStart3d();
   // m_pheroEnd3d = loopFunctions.GetPheroEnd3d();
   // std::cout << "Pheromone location is (" << m_pheroStart3d 
   //           << ") to ( " << m_pheroEnd3d << ")" << std::endl; 
}

void CPheroQTUserFunctions::DrawSome() {
   m_pheroStartArb.Set(0.0,0.0,0.3);
   m_pheroEndArb.Set(0.0,1.0,0.3);
   m_targetPhero.Set(m_pheroStartArb, m_pheroEndArb);
   DrawRay(m_targetPhero,CColor::YELLOW);
}

/****************************************/
/****************************************/

REGISTER_QTOPENGL_USER_FUNCTIONS(CPheroQTUserFunctions, "phero_qt_user_functions")
