// Change to phero 20200602
#ifndef FOOTBOT_PHERO_SENSOR_H
#define FOOTBOT_PHERO_SENSOR_H

#include <string>
#include <map>

namespace argos {
 class CFootBotPheroSensor;
 class CPheroSensorEquippedEntity;
 class CFloorEntity;
}

#include <../../control_interface/ci_footbot_phero_sensor/ci_footbot_phero_sensor.h>
#include <argos3/core/utility/math/range.h>
#include <argos3/core/utility/math/rng.h>
#include <argos3/core/simulator/space/space.h>
#include <argos3/core/simulator/sensor.h>
#include <loop_functions/phero_loop_functions/phero_loop_functions.h>

namespace argos {

 class CFootBotPheroSensor : public CCI_FootBotPheroSensor,
 public CSimulatedSensor {

 public:

 CFootBotPheroSensor();

 virtual ~CFootBotPheroSensor() {}

 virtual void SetRobot(CComposableEntity& c_entity);

 virtual void Init(TConfigurationNode& t_tree);

 virtual void Update();

 virtual void Reset();

 protected:

 CEmbodiedEntity* m_pcEmbodiedEntity;

 //CFloorEntity* m_pcFloorEntity;

 CPheroSensorEquippedEntity* m_pcPheroSensorEntity;

 CPheroLoopFunctions& m_pcLoopFunctions;

 //CRandom::CRNG* m_pcRNG;

 //bool m_bAddNoise;

 //CRange<Real> m_cNoiseRange;

 CSpace& m_cSpace;
 };

}

#endif